import sys
sys.setrecursionlimit(5000)

def lire_graphe(nom_fichier : str) -> dict:
    """
    Renvoie un dictionnaire qui à chaque sommet (de type str) associe
    la liste de ses voisins (de type str)
    
    C'est une représentation qu'on appelle par "liste d'adjacence"
    
    Par exemple { 'A' : ['B','D'], 'B' : ['A'], 'C' : ['A'] }
    """
    fichier = open(nom_fichier)
    nb_sommets = int(fichier.readline())
    nb_aretes = int(fichier.readline())
    graphe = {}
    for i in range(nb_sommets):
        sommet = fichier.readline().strip()
        graphe[sommet] = []
    for i in range(nb_aretes):
        sommet1, sommet2 = fichier.readline().strip().split(" ")
        graphe[sommet1].append(sommet2)
        graphe[sommet2].append(sommet1)
    return graphe

def parcours(sommet):
    pass